#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "gpi.h"

void GP_error(char *name_variable, char *message);

char  *GP_sfetch(char *name_variable, char *def_val, char *message)
{
  char *string;

  string = (char *) malloc(((size_t) (MAX_STRING_LENGTH)));

  if(sfetch(name_variable,string)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
      return string;
}

double GP_dfetch(char *name_variable, double def_val, char *message)
{
  double val;
  if (dfetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
    return val;
}
   
float GP_ffetch(char *name_variable, double def_val, char *message)
{
  float val;
  if (ffetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return ((float) def_val);
    }
  else 
    return val;
}
   

int GP_ifetch(char *name_variable, int def_val, char *message)
{
  int val;

  if (ifetch(name_variable,&val)==0)
    {
      GP_error(name_variable,message);
      return def_val;
    }
  else 
    return val;
}
   
void GP_error(char *name_variable, char *message)
{
  
  if (strcmp(message,"DEFAULT") == 0) 
    return;
  else if (strcmp(message,"WARNING") == 0) 
    {
      fprintf(stderr,"WARNING: using for %s the default value. \n", 
	      name_variable);
      return;
    }
  else if (strcmp(message,"SEVERE") == 0) 
    {
      fprintf(stderr,"SEVERE: the value for %s is not in the input files\n",name_variable);
      exit(-1);
    }
  else 
    {
      fprintf(stderr,"GetparC: allowed message values: DEFAULT, WARNING, SEVERE\n");
      exit(-1);
    }
}
