#include <stdlib.h>
#include "gpi.h"
#include <string.h>
#include <stdio.h>
#include <malloc.h>

static int opened=0;

void strcpy_noblanks(char *target, char *source, int input_count); 


int GP_read_parfile(void)
     /* puts  legal lines of input  into gp_lines_of_text */ 

{
  char * line, * line_aux; 
  char *p2, *p;
  int count = 0, input_count=0;
  FILE * parfilefd=NULL;

  line = (char *) malloc(((size_t) MAX_LINE_LENGTH));
  line_aux = (char *) malloc(((size_t) MAX_LINE_LENGTH));
  parname = (char **) malloc(sizeof (char *) * (NLINES_MAX + 1));
  parvalue = (char **) malloc(sizeof (char *) * (NLINES_MAX + 1));

  if(opened == 1)
    {
      printf("GetparC: Warning: read_parfile already called\n");
      return 0;
    }
    /* Get a line from standard input */

#ifdef HAVE_MPI
      printf("Getpar: reading parfile parJ\n");
      parfilefd = fopen("parJ","r");
      if(parfilefd == NULL) printf("Getpar: failed to open parJ\n");
#else
      parfilefd=stdin;
#endif

    while (fgets(line,MAX_LINE_LENGTH,parfilefd) && (count < NLINES_MAX))
      {
	input_count++;
	/*   eventual comments at end of line are discarded   */
	if((p = strchr(line,'#')) != NULL) *p = '\0';
	if((p = strchr(line,'!')) != NULL) *p = '\0';
	strcpy(line_aux,line);
	  
	/* check that line contains the = sign */

	if((p = strchr(line,'=')) != NULL) 
	{
	  /* Divide the line into tokens separated by the = sign */
	  if((p = strtok(line_aux,"=")) == NULL) 
	    {
	      fprintf(stderr,"GP: line %d: illegaly formatted line\n",input_count);
	      exit(-1);
	    }
	  else
	    {
	      /* Check that there is a second word */
	      if((p2 = strtok(NULL,"=")) == NULL) 
		{
		  fprintf(stderr,"GP: line %d: illegaly formatted line\n",input_count);
		  exit(-1);
		}
	      else
		{
		  parname[count] = (char *) malloc(((size_t) MAX_STRING_LENGTH)); 
		  strcpy_noblanks(parname[count],p,input_count);
		  parvalue[count] = (char *) malloc(((size_t) MAX_STRING_LENGTH)); 
		  strcpy(parvalue[count],p2);
		  count++;
		}
	    }
	}
      }
    parname[count] = NULL;
    parvalue[count] = NULL;

    free(line);
    free(line_aux);

  /* Record that parfile was read */

    opened=1;
    return count;
}

void read_stdin_()
{
  int   lines;
  lines = GP_read_parfile();
}

void strcpy_noblanks(char *target, char *source, int input_count)
{
  /* Copies string source to string target stripping all leading and trailing
     blanks. If more than one word is present, complain. */

  char *p, *p2, *string_aux;

  string_aux = (char *) malloc(((size_t) MAX_STRING_LENGTH));
  strcpy(string_aux,source);
  if((p = strchr(source,' ')) != NULL) 
    {
      /* Divide the line into tokens separated by blanks  */
      if((p = strtok(string_aux," ")) == NULL) 
	{
	  fprintf(stderr,"GP: line %d: blank parameter name?\n",input_count);
	  exit(-1);
	}
      else
	{
	  /* Check that there no second word */
	  if((p2 = strtok(NULL," ")) != NULL) 
	    {
	      fprintf(stderr,"GP: line %d: multi-word parameter name\n",input_count);
	      exit(-1);
	    }
	  else
	    {
	      strcpy(target,p);
	    }
	}
    }
  else
    strcpy(target,source);
  free(string_aux);
}


int GP_opened()
{
  return opened;
}

